SystemOrganization addCategory: #'Magritte-Scriptaculous'!

MATextInputComponent subclass: #MAAutoCompletingTextInputComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Scriptaculous'!

!MAAutoCompletingTextInputComponent commentStamp: 'kph 1/10/2008 02:12' prior: 0!
At present we obtain the list from the model, via the accessor supplied at the accessor's, #options.

We can alternatively get it from the memento via a description obtained from the model class, #listDescriptionSelector

We also have an #inputExampleText property (as an addition to our superclass)

and #listMax

When completed we redraw our parent.!

!MAAutoCompletingTextInputComponent class methodsFor: 'as yet unclassified' stamp: 'kph 11/19/2007 04:32'!
isAbstract

 ^ false! !

!MAAutoCompletingTextInputComponent methodsFor: 'as yet unclassified' stamp: 'kph 1/4/2008 23:08'!
exampleText

	^ self description propertyAt: #inputExampleText ifAbsent: ['']! !

!MAAutoCompletingTextInputComponent methodsFor: 'as yet unclassified' stamp: 'kph 1/10/2008 03:49'!
filter
	" #left #right #substring (default) #match"
	
	^ self description propertyAt: #filter ifAbsent: [ #substring ]! !

!MAAutoCompletingTextInputComponent methodsFor: 'as yet unclassified' stamp: 'kph 1/10/2008 03:01'!
isAutoSelect

	^ self description propertyAt: #autoSelect ifAbsent: false! !

!MAAutoCompletingTextInputComponent methodsFor: 'as yet unclassified' stamp: 'kph 1/10/2008 02:32'!
isUpdating

	^ self description accessor update notNil! !

!MAAutoCompletingTextInputComponent methodsFor: 'filters' stamp: 'kph 1/10/2008 03:55'!
left
	^ self list select: [ :each | (each asString findString: self string startingAt: 1 caseSensitive: false) = 1 ].! !

!MAAutoCompletingTextInputComponent methodsFor: 'as yet unclassified' stamp: 'kph 1/7/2008 02:36'!
list

	self listDescription ifNotNilDo: [ :desc | ^ self memento readUsing: desc  ].
	 
	^ self memento model readUsing: (MADescription basicNew accessor: (self description accessor options ifNil: [ ^ #() ]) ).
	
 ! !

!MAAutoCompletingTextInputComponent methodsFor: 'as yet unclassified' stamp: 'kph 11/19/2007 20:23'!
listDescription

	^ self memento model class perform: (self listDescriptionSelector ifNil:[ ^nil ])! !

!MAAutoCompletingTextInputComponent methodsFor: 'as yet unclassified' stamp: 'kph 11/19/2007 20:21'!
listDescriptionSelector

	^ self description propertyAt: #listDescriptionSelector ifAbsent: nil! !

!MAAutoCompletingTextInputComponent methodsFor: 'as yet unclassified' stamp: 'kph 1/10/2008 03:35'!
listFiltered

	^ self perform: self filter! !

!MAAutoCompletingTextInputComponent methodsFor: 'as yet unclassified' stamp: 'kph 11/20/2007 00:11'!
listMax
	^ self description propertyAt: #listMax ifAbsent: [ self listMaxDefault ]! !

!MAAutoCompletingTextInputComponent methodsFor: 'as yet unclassified' stamp: 'kph 11/20/2007 00:12'!
listMaxDefault
	^  10! !

!MAAutoCompletingTextInputComponent methodsFor: 'as yet unclassified' stamp: 'kph 1/10/2008 03:56'!
match

	| match |
	
	match := '*' , self string.
	 
	^ self list select: [ :each | match match: each asString ].
	! !

!MAAutoCompletingTextInputComponent methodsFor: 'rendering' stamp: 'kph 1/10/2008 03:01'!
renderEditorOn: html
	| input p whenSelected |
 
	p := self parent.
	
	input := self labelId.
	html textInput
		attributes: self attributes;
		id: input;
		value: self string;
		exampleText: self exampleText;
		"onChange: (html request
					triggerFormElement: input);"
		callback: [ :v | self string: v ].
	
	whenSelected := html request.
					
	self isUpdating ifTrue: [ 
		whenSelected 
			triggerFormElement: input; 
			onSuccess: (html updater id: (p id); callback: [ :r | self log info: p id.  p updateContentOn: r] )
	].  
		
	html div 
		class: 'autocomplete';
		script: (html autocompleter
			element: input;
			autoSelect: self isAutoSelect;
			onSelected: whenSelected;
			on: #renderListOn: of: self)
		 ! !

!MAAutoCompletingTextInputComponent methodsFor: 'as yet unclassified' stamp: 'kph 1/10/2008 02:18'!
renderListOn: html

	| items |
	
	items := self listFiltered.

	html unorderedList list: (items first: (items size min: self listMax))! !

!MAAutoCompletingTextInputComponent methodsFor: 'filters' stamp: 'kph 1/10/2008 03:58'!
right
	
	^ self list select: [ :each | 	
		| extra |
 
		(extra := each asString size - self string size) < 0 
			ifTrue: [ false ]
			ifFalse: [
				 (each asString findString: self string startingAt: extra + 1 caseSensitive: false) > 0
			]
		]
	
 ! !

!MAAutoCompletingTextInputComponent methodsFor: 'rendering' stamp: 'kph 11/19/2007 22:19'!
style
	^ 'input#text {
	width: 250px;
}
div.autocomplete {
	position: absolute;
	background-color: white;
	border: 1px solid #888;
	margin: 0px;
	padding: 0px;
	z-index: 1000;
}
div.autocomplete ul, div.autocomplete ul li {
	list-style-type: none;
	line-height: 1.7;
	margin: 0px;
	padding: 0px;
}
div.autocomplete ul li.selected {
	background-color: #ffb;
}'! !

!MAAutoCompletingTextInputComponent methodsFor: 'filters' stamp: 'kph 1/10/2008 03:56'!
substring
	^ self list select: [ :each | each asString includesSubstring: self string caseSensitive: false ].
	
 ! !

!MAFileModel class methodsFor: '*magritte-scriptaculous' stamp: 'kph 1/10/2008 12:05'!
descriptionFile
	 
	^ MAFileDescription new
		kind: self;
		reportColumnClass: MADescribedRenderedColumn;
		accessor: #file;
		label: 'File';
		yourself! !

!MAFileModel methodsFor: '*magritte-scriptaculous' stamp: 'kph 1/10/2008 12:04'!
file

	^ self! !

!MAComponentRenderer methodsFor: '*magritte-scriptaculous-override' stamp: 'kph 1/7/2008 09:07'!
renderContainer: aDescription
	self visitAll: (aDescription select: [ :each |
		(each isVisibleForItem: component memento)
		and: [ each componentClass notNil ] ])! !

!BlockContext methodsFor: '*magritte-scriptaculous' stamp: 'kph 1/6/2008 20:53'!
read: anObject description: aDescription

	^ self value: anObject! !

!BlockContext methodsFor: '*magritte-scriptaculous' stamp: 'kph 1/6/2008 20:52'!
write: anObject description: aDescription

	^ self value: anObject! !

MADateInputComponent variableSubclass: #MADateInputShoreComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Scriptaculous'!

!MADateInputShoreComponent methodsFor: 'as yet unclassified' stamp: 'kph 1/7/2008 00:46'!
ShoreDatePicker

	^ Smalltalk at: #ShoreDatePicker ifAbsent: [ self error: 'Shore Components not loaded' ]! !

!MADateInputShoreComponent methodsFor: 'as yet unclassified' stamp: 'kph 1/7/2008 00:46'!
renderEditorOn: html

	| picker |

	picker := self ShoreDatePicker in: html.
	picker on: #string of: self.! !

!MAAccessor methodsFor: '*magritte-scriptaculous' stamp: 'kph 11/20/2007 11:01'!
asAccessor

^ self ! !

!MAAccessor methodsFor: '*magritte-scriptaculous' stamp: 'kph 1/7/2008 09:04'!
cssClass

   ^ self propertyAt: #cssClass ifAbsent: [ nil ]! !

!MAAccessor methodsFor: '*magritte-scriptaculous' stamp: 'kph 1/7/2008 09:04'!
cssClass: selectorOrAccessor

   self propertyAt: #cssClass put: selectorOrAccessor asAccessor
	
 ! !

!MAAccessor methodsFor: '*magritte-scriptaculous' stamp: 'kph 11/22/2007 04:38'!
options

   ^ self propertyAt: #options ifAbsent: [ nil ]! !

!MAAccessor methodsFor: '*magritte-scriptaculous' stamp: 'kph 11/22/2007 04:39'!
options: selectorOrAccessor

   self propertyAt: #options put: selectorOrAccessor asAccessor
	
 ! !

!MAAccessor methodsFor: '*magritte-scriptaculous' stamp: 'kph 11/21/2007 00:01'!
readonly 

   ^ self propertyAt: #readonly ifAbsent: [ nil ]! !

!MAAccessor methodsFor: '*magritte-scriptaculous' stamp: 'kph 11/21/2007 00:01'!
readonly: selectorOrAccessor

   self propertyAt: #readonly put: selectorOrAccessor asAccessor
	
 ! !

!MAAccessor methodsFor: '*magritte-scriptaculous' stamp: 'kph 12/14/2007 10:58'!
tooltip

   ^ self propertyAt: #tooltip ifAbsent: [ nil ]! !

!MAAccessor methodsFor: '*magritte-scriptaculous' stamp: 'kph 12/14/2007 10:58'!
tooltip: selectorOrAccessor

   self propertyAt: #tooltip put: selectorOrAccessor asAccessor
	
 ! !

!MAAccessor methodsFor: '*magritte-scriptaculous' stamp: 'kph 11/20/2007 11:01'!
update 

   ^ self propertyAt: #update ifAbsent: [ self ]! !

!MAAccessor methodsFor: '*magritte-scriptaculous' stamp: 'kph 11/20/2007 10:56'!
update: selectorOrAccessor

   self propertyAt: #update put: selectorOrAccessor asAccessor
	
 ! !

!MAAccessor methodsFor: '*magritte-scriptaculous' stamp: 'kph 11/20/2007 10:59'!
update: anObject to: aModel
	"Write ==anObject== to ==aModel== using the access-strategy of the receiver."

	self update write: anObject to: aModel! !

!MAAccessor methodsFor: '*magritte-scriptaculous' stamp: 'kph 11/22/2007 04:36'!
visible 

   ^ self propertyAt: #visible ifAbsent: [ nil ]! !

!MAAccessor methodsFor: '*magritte-scriptaculous' stamp: 'kph 11/30/2007 00:34'!
visible: selectorOrAccessor

   self propertyAt: #visible put: selectorOrAccessor asAccessor
	
 ! !

MAOneToManyComponent subclass: #MAOneToManyDocumentsComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Scriptaculous'!

!MAOneToManyDocumentsComponent commentStamp: 'kph 1/10/2008 12:13' prior: 0!
Component for uploading multiple files to one attribute of a model

usage:

descriptionDocuments

	^ MAToManyRelationDescription new
		classes: (Array with: WAExternalFileModel  "or custom subclass");
		accessor: #documents;
		componentClass: MAOneToManyDocumentsComponent;
 		label: 'Documents';
   		bePersisted;
		yourself!

!MAOneToManyDocumentsComponent methodsFor: 'as yet unclassified' stamp: 'kph 1/8/2008 05:15'!
add: it
 self value: (self value copyWith: it).
 self refresh.
! !

!MAOneToManyDocumentsComponent methodsFor: 'as yet unclassified' stamp: 'kph 1/8/2008 01:44'!
buildCommands
	commands := MACommandColumn new
				setReport: self report.

	self description isDefinitive
		ifFalse: [ commands
					addCommandOn: self selector: #rename: ;
					addCommandOn: self selector: #delete:    ].

	^ commands! !

!MAOneToManyDocumentsComponent methodsFor: 'as yet unclassified' stamp: 'kph 1/8/2008 03:17'!
buildReport
	^ (super buildReport)
		 showHeader: false;
		 tableEmpty: '(no documents)';
		 yourself
		
	! !

!MAOneToManyDocumentsComponent methodsFor: 'as yet unclassified' stamp: 'kph 1/10/2008 11:29'!
delete: a
	a finalize..
	^ self remove: a! !

!MAOneToManyDocumentsComponent methodsFor: 'as yet unclassified' stamp: 'kph 1/8/2008 04:49'!
isMultipart

	^ true! !

!MAOneToManyDocumentsComponent methodsFor: 'as yet unclassified' stamp: 'kph 1/10/2008 12:03'!
renderSelectButtonOn: html
	"html submitButton on: #upload of: self"
 
	html fileUpload
		on: #upload of: self.
	html submitButton
		text: 'upload'
 ! !

!MAOneToManyDocumentsComponent methodsFor: 'as yet unclassified' stamp: 'kph 1/10/2008 11:56'!
upload: aFile
	aFile ifNil: [ ^ self ].
	
 	self add: (
	
		self description commonClass new 
				mimetype: aFile contentType;
				filename: aFile fileName;
				contents: aFile contents;
				yourself ) ! !

!WATagBrush methodsFor: '*magritte-scriptaculous' stamp: 'kph 1/7/2008 09:20'!
classes: aList
	self class: (aList reduce: [ :a :b | a , ' ' , b ])! !

!MAValidatorVisitor methodsFor: '*magritte-scriptaculous-override' stamp: 'lr 7/12/2007 18:42'!
visitDescription: aDescription
	"Validate the current object using aDescription within an exception handler to avoid running further tests that might cause error-cascades."

	aDescription isVisible ifFalse: [ ^ self ].
	[ self validate: self object using: aDescription ]
		on: MAValidationError
		do: [ :err | err beResumable; pass ]! !

MADescribedColumn subclass: #MADescribedRenderedColumn
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Scriptaculous'!

!MADescribedRenderedColumn commentStamp: 'kph 1/10/2008 12:09' prior: 0!
This column kicks the rendering of the cell back to the description #renderCellContent: value on: html in: table!

!MADescribedRenderedColumn methodsFor: 'as yet unclassified' stamp: 'kph 1/8/2008 02:52'!
renderCellContent: anObject on: html
	self description renderCellContent: anObject on: html in: self! !

MAListCompositonComponent subclass: #MAListCompositonComponentSU
	instanceVariableNames: 'id availableId selectedId'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Scriptaculous'!

!MAListCompositonComponentSU methodsFor: 'as yet unclassified' stamp: 'kph 9/20/2007 10:26'!
formId

	^ self labelId, '-f'! !

!MAListCompositonComponentSU methodsFor: 'as yet unclassified' stamp: 'kph 11/13/2007 23:54'!
renderEditorAvailableOn: html

	html select
		attributes: self attributes;
		id: availableId;
		size: 6; style: 'width: 250px';
		list: self availableList;
		selected: self availableSelected;
		callback: [ :value | self availableSelected: value ];
		labels: [ :value | self labelForOption: value ]! !

!MAListCompositonComponentSU methodsFor: 'as yet unclassified' stamp: 'kph 9/26/2007 17:18'!
renderEditorButtonAddOn: html

	html button
		onClick:  (html updater
					id: id;
					triggerFormElement: availableId;
					callback: [ :r | self add; updateEditorOn: r ];
					return: false);
		with: '>>'.
	html break.
	html button
		onClick: (html updater
					id: id;
					triggerFormElement: selectedId;
					callback: [ :r | self remove; updateEditorOn: r ];
					return: false);
		with: '<<'! !

!MAListCompositonComponentSU methodsFor: 'as yet unclassified' stamp: 'kph 9/26/2007 17:18'!
renderEditorButtonOrderOn: html

	html button
		onClick:  (html updater
					id: id;
					triggerFormElement: selectedId;
					callback: [ :r | self moveUp; updateEditorOn: r ];
					return: false);
		text: 'up'.
	html break.
	html button
		onClick:  (html updater
					id: id;
					triggerFormElement: selectedId;
					callback: [ :r | self moveDown; updateEditorOn: r ]; 
					return: false);
		text: 'down'! !

!MAListCompositonComponentSU methodsFor: 'as yet unclassified' stamp: 'kph 9/26/2007 17:13'!
renderEditorOn: html 
	id := html nextId.
	availableId := html nextId.
	selectedId := html nextId.
	html div
		id: id;
		with: 
			 [self updateEditorOn: html] ! !

!MAListCompositonComponentSU methodsFor: 'as yet unclassified' stamp: 'kph 11/13/2007 23:54'!
renderEditorSelectedOn: html
 	html select
		attributes: self attributes;
		id: selectedId;
		size: 6; style: 'width: 250px';
		list: self selectedList;
		selected: self selectedSelected;
		callback: [ :value | self selectedSelected: value ];
		labels: [ :value | self labelForOption: value ]! !

!MAListCompositonComponentSU methodsFor: 'as yet unclassified' stamp: 'kph 9/16/2007 08:56'!
updateEditorOn: html
		super renderEditorOn: html! !

!MAListCompositonComponentSU methodsFor: 'as yet unclassified' stamp: 'kph 9/20/2007 10:26'!
updateId

	^ self labelId, '-u'! !

MASelectListComponent subclass: #MASelectListComponentSU
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Scriptaculous'!

!MASelectListComponentSU methodsFor: 'as yet unclassified' stamp: 'kph 12/20/2007 10:23'!
renderEditorOn: html

	

	html select
		attributes: self attributes;
		id: self labelId;
		list: self options;
		selected: self value;
		callback: [ :value | self value: value ];
		onChange: (html updater 
						id: (parent id); 
						triggerFormElement: (self labelId);
						callback: [ :r | self log info: parent id. parent updateContentOn: r] );
		labels: [ :value | self labelForOption: value ]! !

!MAOptionDescription methodsFor: '*magritte-scriptaculous' stamp: 'kph 1/7/2008 08:38'!
optionsFor: item

	^ item readUsing: (MADescription basicNew accessor: (self accessor options ifNil: [ ^ self options ]))

! !

!MADescriptionComponent methodsFor: '*magritte-scriptaculous-override' stamp: 'kph 1/7/2008 09:14'!
isReadonly
	(self isRoot not and: [self parent isReadonly]) ifTrue: [^ true].
	^ self description isReadonlyForItem: self memento ! !

!MADescription methodsFor: '*magritte-scriptaculous-override' stamp: 'kph 12/14/2007 10:06'!
accessor: anAccessor
	accessor := anAccessor asAccessor! !

!MADescription methodsFor: '*magritte-scriptaculous' stamp: 'kph 1/7/2008 09:37'!
cssClassForItem: item
	 
	^ (item readUsing: (MADescription basicNew accessor: (self accessor cssClass ifNil: [ ^ self cssClass ]))) ifNil: [ self cssClass ]! !

!MADescription methodsFor: '*magritte-scriptaculous' stamp: 'kph 1/7/2008 09:30'!
cssClassesForItem: item
	 
	 | classes |
	classes := OrderedCollection with: (self cssClassForItem: item).
	(self isReadonlyForItem: item)
		ifTrue: [ classes add: 'readonly' ].
	self isRequired
		ifTrue: [ classes add: 'required' ].
	^ classes! !

!MADescription methodsFor: '*magritte-scriptaculous' stamp: 'kph 1/7/2008 09:12'!
isReadonlyForItem: item
	 
	^  item readUsing: (MADescription basicNew accessor: (self accessor readonly ifNil: [ ^ self isReadonly ]))! !

!MADescription methodsFor: '*magritte-scriptaculous' stamp: 'kph 1/7/2008 09:05'!
isVisibleForItem: item
	 
	^ self isVisible and: [ item readUsing: 
		(MADescription basicNew accessor: (self accessor visible ifNil: [ ^ self isVisible ]))]! !

!MADescription methodsFor: '*magritte-scriptaculous' stamp: 'kph 1/8/2008 02:51'!
renderCellContent: anObject on: html in: report
	"this render method is used if the description is set to have reportColumnClass = MADescribedSelfRenderingColumn"
	| value |
	value := (anObject readUsing: self) ifNil: [ self default ].
	
	html render: (self toString: value)! !

!MADescription methodsFor: '*magritte-scriptaculous' stamp: 'kph 1/7/2008 01:51'!
tooltipForItem: item
	 
	^ item readUsing: (MADescription basicNew accessor: (self accessor tooltip ifNil: [ ^ self comment ]))! !

!MATableRenderer methodsFor: '*magritte-scriptaculous-override' stamp: 'kph 1/7/2008 09:32'!
renderControl: aDescription

	| classes | 
	
	classes := aDescription cssClassesForItem: (self childAt: aDescription) model.

	(self hasError: aDescription)	ifTrue: [ classes add: 'error' ].

	html tableData
		classes: classes;
		with: [ super renderControl: aDescription ]
		! !

!MATableRenderer methodsFor: '*magritte-scriptaculous-override' stamp: 'kph 1/7/2008 01:49'!
renderElement: aDescription
	html tableRow
	 	title: (aDescription tooltipForItem:  (self childAt: aDescription) model);
		with: [ super renderElement: aDescription ]! !

!MAChainAccessor methodsFor: '*magritte-scriptaculous-override' stamp: 'kph 12/14/2007 10:07'!
accessor: anAccessor
	accessor := anAccessor asAccessor! !

!MAChainAccessor methodsFor: '*magritte-scriptaculous-override' stamp: 'kph 12/14/2007 10:07'!
next: anAccessor
	next := anAccessor asAccessor! !

!MAContainerComponent methodsFor: '*magritte-scriptaculous-override' stamp: 'kph 11/20/2007 12:19'!
renderContentOn: html
	html div
		id: self id;
		with: [ 	self updateContentOn: html ]! !

!MAContainerComponent methodsFor: '*magritte-scriptaculous' stamp: 'kph 12/20/2007 11:09'!
updateContentOn: html
	
	self description componentRenderer
		component: self on: html! !
